#include <stdio.h>
#include <string.h>

//-----------------------------------------------------------
//
// Hack because the lame Mac compiler's fputc doesn't work
//
//-----------------------------------------------------------

void my_fputc( char c, FILE *fp )
{
	fwrite(&c,1,1,fp);
}

#define fputc my_fputc

int strcmpi ( char *s1, char *s2 )
{
	int c1,c2;
	do {
		c1=*s1++;
		c2=*s2++;
		if (c1>='a' && c1<='z') c1+= 'A'-'a';
		if (c2>='a' && c2<='z') c2+= 'A'-'a';
	} while (c1==c2 && c1 && c2);
	return (c1==c2) ? 0 : (c2>c1) ? 1 : -1;
}

//-----------------------------------------------------------

#define	COUNT_OFFSET	0x4C
#define	TABLE_OFFSET	0x50

#define	TYPE_COUNT		12

static char type_names[ TYPE_COUNT ][50] = {
	"American",
	"Chinese", 
	"Fastfood",
	"French",   
	"Indian",   
	"Italian",  
	"Japanese", 
	"Meditrrn",
	"Mexican",  
	"Sandwich", 
	"Thai",
	"Other",    
};

#define	CLASS_COUNT		5

static char class_names[ CLASS_COUNT ][10] = {

	"Fast", 
	"Cheap",
	"Nice", 
	"Outs", 
	"Card"  
};


int main( int argc, char **argv )
{
	char buf1[100];
	char buf2[100];
	char buf3[200];
	char *name1;
	char *name2;
	FILE *i_fp, *o_fp;
	short count,types,classes;
	unsigned long offset,size;
	int i,j,k, is_mac = 1;

	if (argc>=1) {
		int len=strlen(argv[0]);
		if (len>4 && !strcmpi(&argv[0][len-4],".exe")) is_mac = 0;
	}

	printf("Meal2Txt v3.41C\n");
	printf("By Vince Lee (c)1997-2000 TealPoint Software.\n\n");

	printf("   Restaurant database extraction utility\n");
	printf("   accompanying TealMeal for the 3Com Connected Organizers.\n\n");

	if (argc > 1 && (argv[1][0]=='?' || argv[1][1]=='?')) {
		printf("   Usage: Meal2Txt <input database file> <output text file>\n");
		goto quit;
	}

	else if (argc >= 2) {

		name1 = argv[1];
		name2 = argv[2];

	} else {

		printf("Enter path to source database file (e.g. City.PDB) -> ");
		scanf( "%s", buf1 );

		if (strlen(buf1) < 4 ||
			strcmpi(buf1+strlen(buf1)-4,".PDB" )) {
			strcat(buf1,".PDB");
		}

		printf("\nEnter target text file (e.g. City.txt) -> ");
		scanf( "%s", buf2 );

		name1 = buf1;
		name2 = buf2;

	}

	if (i_fp = fopen( name1, "rb" )) {
		if (o_fp = fopen( name2, "wt" )) {

			//
			// Print Header
			//

			fprintf( o_fp, "#\n");
			fprintf( o_fp, "# TealMeal Restaurant Database Creation File.\n");
			fprintf( o_fp, "# Created using meal2txt v1.1\n");
			fprintf( o_fp, "#\n");

			//
			// Num Records
			//

			fseek( i_fp, COUNT_OFFSET, SEEK_SET );
			count  = fgetc( i_fp ) << 8;
			count |= fgetc( i_fp );

			fprintf( o_fp, "# NumRecords: %d\n",count );

			//
			// Extract Each Record
			//

			for (i=0; i<count; i++) {

				if (i<count-1) {
					fseek( i_fp, TABLE_OFFSET+((i+1)<<3), SEEK_SET );

					size  = fgetc( i_fp ) << 8;
					size |= fgetc( i_fp );
					size &= 0xffff;
				} else {
					fseek( i_fp, 0, SEEK_END );
					size  = ftell( i_fp );
				}

				//
				// Seek to Record
				//

				fseek( i_fp, TABLE_OFFSET+(i<<3), SEEK_SET );

				offset  = fgetc( i_fp ) << 8;
				offset |= fgetc( i_fp );
				offset &= 0xffff;

				size -= offset;

				//
				// Get Type and Class Bits
				//

				if (i) fprintf( o_fp, ">>>\n" );		// write record separator

				fseek( i_fp, offset, SEEK_SET );

				types    = fgetc( i_fp ) << 8;
				types   |= fgetc( i_fp );
				classes  = fgetc( i_fp ) << 8;
				classes |= fgetc( i_fp );

				//
				// Custom labels
				//

				if (!types && !classes && !i) {
					int c;
					char ts[2];

					ts[1] = 0;

 					do {
						c = fgetc(i_fp);
					} while( c && c!=EOF );

					// Write Header

					fprintf(o_fp,"Custom Labels\n");

					// Write Types

					for (j=0; j<TYPE_COUNT; j++) {
						type_names[j][0]=0;
	 					do {
							c = ts[0] = fgetc(i_fp);
							if (c && c!=EOF) {
								fputc(c,o_fp);
								strcat( type_names[j],ts );
							}
						} while( c && c!=EOF );

						for ( k=0; type_names[j][k]; k++ ) if (type_names[j][k]==' ') type_names[j][k]='_';
						fprintf(o_fp,"\n");
					}

					// Write Classes

					for (j=0; j<CLASS_COUNT; j++) {
						class_names[j][0]=0;
	 					do {
							c = ts[0] = fgetc(i_fp);
							if (c && c!=EOF) {
								fputc(c,o_fp);
								strcat( class_names[j],ts );
							}
						} while( c && c!=EOF );

						for ( k=0; class_names[j][k]; k++ ) if (class_names[j][k]==' ') type_names[j][k]='_';
						fprintf(o_fp,"\n");
					}

					// Write Comments

					{  char *tptr; int c=0,lc;
	
						tptr = buf3;
	
						c = fgetc(i_fp);
						while (c!=EOF && ftell(i_fp) < offset+size) {
	
							if (!c) break;
	
							if (c==0x0a) fprintf( o_fp, "\n" );		// convert cr's to local format
							else 			 fputc( c, o_fp );			// output character

							lc = c;
							c = fgetc(i_fp);
						}
						if (lc!=0x0a) fprintf( o_fp, "\n" );
					}
				}

				else {

					//
					// Get Name
					//
	
					{  char *tptr; int c;
	
						tptr = buf3;
	
						while ((c=fgetc(i_fp)) != EOF) {
	
							if (!c) break;
	
							if (c==0x0a) fprintf( o_fp, " " );		// convert cr's to spaces
							else 			 fputc( c, o_fp );			// output character
						}
						fprintf( o_fp, "\n" );
					}
	
					//
					// Write Flags
					//
	
					{ int j;
	
	
						fprintf(o_fp,"\t");
						for (j=0; j<TYPE_COUNT; j++) {
							if (types & (1L<<j)) fprintf( o_fp, "%s ", type_names[j] );
						}
						fprintf(o_fp,"\n\t");
						for (j=0; j<CLASS_COUNT; j++) {
							if (classes & (1L<<j)) fprintf( o_fp, "%s ", class_names[j] );
						}
						fprintf(o_fp,"\n");
					}
	
					//
					// Get Description
					//
	
					{  char *tptr; int c;
	
						tptr = buf3;
	
						while ((c=fgetc(i_fp)) != EOF) {
	
							if (!c) break;
	
							if (c==0x0a) fprintf( o_fp, "\n" );		// convert cr's to local format
							else 			 fputc( c, o_fp );			// output character
						}
						fprintf( o_fp, "\n" );
					}
				}
			}

			printf("   Extracted %d records (%ld bytes)\n",count,ftell(o_fp));

			fclose( o_fp );

		} else printf("Can't write file %s\n",name2);

		fclose( i_fp );

	} else printf("Can't read file %s\n",name1);

quit:
	if (is_mac) {
		printf("Done.  Choose 'Quit' from the 'File' menu to exit.\n");
	}
	return 0;
}

