#include <stdio.h>
#include <string.h>

//-----------------------------------------------------------
//
// Hack because the lame Mac compiler's fputc doesn't work
//
//-----------------------------------------------------------

void my_fputc( char c, FILE *fp )
{
	fwrite(&c,1,1,fp);
}

#define fputc my_fputc

int strcmpi ( char *s1, char *s2 )
{
	int c1,c2;
	do {
		c1=*s1++;
		c2=*s2++;
		if (c1>='a' && c1<='z') c1+= 'A'-'a';
		if (c2>='a' && c2<='z') c2+= 'A'-'a';
	} while (c1==c2 && c1 && c2);
	return (c1==c2) ? 0 : (c2>c1) ? 1 : -1;
}

int strnicmp ( char *s1, char *s2, int count )
{
	int c1,c2;
	do {
		c1=*s1++;
		c2=*s2++;
		if (c1>='a' && c1<='z') c1+= 'A'-'a';
		if (c2>='a' && c2<='z') c2+= 'A'-'a';
	} while (c1==c2 && c1 && c2 && --count>0);
	return (c1==c2) ? 0 : (c2>c1) ? 1 : -1;
}

//-----------------------------------------------------------
//
// Database header
//
//-----------------------------------------------------------

#define HEADER_SIZE (9*8+4)

static char data_header[HEADER_SIZE] = {
	0x54,0x65,0x61,0x6c,0x4d,0x65,0x61,0x6c,   // TealMeal	name(32)
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,   // ........
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,   // ........
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,   // ........
	0x00,0x08,0x00,0x00,0x33,0xb8,0xbd,0xa5,   // ....3..#	attr.w ver.w creat_date.l
	0x33,0xb8,0xbd,0xa5,0x33,0xb8,0xbd,0xa5,   // 3...3...   mod_date.l back_date.l
	0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,   // ........   mod_num.l app_info.l
	0x00,0x00,0x00,0x00,0x44,0x61,0x74,0x61,   // ....Data	app_sort.l type.l
	0x54,0x6c,0x4d,0x6c,0x00,0x00,0x00,0x00,   // TlMl....	creator.l id_seed.l

	0x00,0x00,0x00,0x00,							  	 // ....			record list type -> first header
};

//
// Record count: <count.w>
// Database record entry: <offset.l>, <attr.b>, <unique_id.3b>
//

//
// Middle Section (Categories?)
//	0x00 0x00
//

#define	TABLE_OFFSET	0x4e

#define	TYPE_COUNT		12

static char type_names[ TYPE_COUNT ][40] = {
	"American",
	"Chinese", 
	"Fastfood",
	"French",   
	"Indian",   
	"Italian",  
	"Japanese", 
	"Meditrrn",
	"Mexican",  
	"Sandwich", 
	"Thai",
	"Other",    
};

#define	CLASS_COUNT		5

static char class_names[ CLASS_COUNT ][20] = {

	"Fast", 
	"Cheap",
	"Nice", 
	"Outs", 
	"Card"  
};

// Read String from CSV file
// Return 0 if more, 1 if EOL, 2 if EOF

int ReadString( FILE *i_fp, char *buffer, long size, int line )
{
	int c,skip=0;
	char *tptr = buffer;

	tptr[0] = 0;

	// skip whitespace

	do {
		c = fgetc(i_fp);
		if (c==EOF) {
			printf("ERROR: Unexpected end of file in record %d\n",line);
			return 2;
//			exit(20);
		}
	
	} while (c>0 && c<=32);

	// Check quotes

	if (c!='"') {
		printf("ERROR: Missing quote in record %d\n",line);
		return 2;
//		exit(21);
	}
	
	do {
		skip=0;
		c = fgetc(i_fp);
		if (c=='"') {
			long pos = ftell(i_fp);
			if (fgetc(i_fp)=='"') {
				skip=1;
			} else {
				fseek( i_fp, pos, SEEK_SET );
			}
		}
			
		if ((c!='"' && c!=EOF) || skip) {
			sprintf(tptr, "%c", c );
			tptr++;
		}

	} while (skip || (c!='"' && c!=EOF));

	if (c==EOF) return 2;

	do {
		c = fgetc(i_fp);
		if (c==EOF) return 2;
	} while (c==' ' || c==9);
	return (c==',')?0:1;
}

char *ScanLine( char *string,char *delim )
{
	static char *lstring = 0;
	int i;

	
	if (!string) {
		string = lstring;

		while( string[0]==10 || string[0]==13 ) string++;
	}

	for (i=0; string[i] && string[i]!=10 && string[i]!=13; i++);
	string[i] = 0;

	lstring = string+i+1;
//printf("returning '%s'\n",string );
	return string;
}

int main( int argc, char **argv )
{
	char buf1[100];
	static char buf3[2000];
	static char buf4[2000];
	char buf5[200];
	char *name1;
	char *name2;
	FILE *i_fp, *o_fp;
	short count;
	int i,k,is_mac=1;

	if (argc>=1) {
		int len=strlen(argv[0]);
		if (len>4 && !strcmpi(&argv[0][len-4],".exe")) is_mac = 0;
	}

	printf("Csv2Meal v3.41C\n\n");

	printf("   Restaurant database creation utility\n");
	printf("   accompanying TealMeal for the 3Com PalmPilot.\n\n");

	if (argc > 1 && (argv[1][0]=='?' || argv[1][1]=='?')) {
		printf("   Usage: Csv2Meal <input text file> <output database name>\n");
		goto quit;
	}

	else if (argc >= 2) {

		name1 = argv[1];
		strncpy( data_header, argv[2], 29 );

		if (strlen(argv[2])>4 && !strcmpi(argv[2]+strlen(argv[2])-4, ".PDB")) {

			sprintf( buf5,"%s", argv[2] );
		} else {
			sprintf( buf5,"%s.PDB", argv[2] );
		}
		name2 = buf5;

	} else {

		printf("Enter Name of Source .CSV file (e.g. City.CSV)-> ");
		gets( buf1 );
		printf("\nEnter Database name appearing on Pilot (e.g. Chicago) -> ");
		gets( buf5 );

		name1 = buf1;
		name2 = buf5;

		if (strlen(buf5) > 4 &&
			!strcmpi(buf5+strlen(buf5)-4,".PDB" )) {
			buf5[strlen(buf5)-4] = 0;
		}

		strncpy( data_header, buf5, 29 );
		strcat( buf5, ".PDB" );
	}

	if (i_fp = fopen( name1, "rt" )) {
		if (o_fp = fopen( name2, "wb" )) {
			int c,lc=0,quoted=0;

			//
			// Count records
			//

			count = 0;

			while( (c = fgetc (i_fp)) != EOF ) {
				if (c=='"') quoted = !quoted;
				if (quoted && c=='"' && (lc==10 || lc==13)) count++;
				lc = c;
			}
			if (lc=='"') count++;

			fseek ( i_fp, 0, SEEK_SET );

			//
			// Output database header
			//

			fwrite ( data_header, HEADER_SIZE, 1, o_fp );	// record
			fputc  ( count>>8,  o_fp );						// count.w
			fputc  ( count&255, o_fp );

			//
			// Output temporary record headers (8-bytes each)
			//

			for (i=0; i<count; i++) {
				fputc  ( 0, o_fp );
				fputc  ( 0, o_fp );
				fputc  ( 0, o_fp );
				fputc  ( 0, o_fp );
				fputc  ( 0, o_fp );
				fputc  ( 0, o_fp );
				fputc  ( 0, o_fp );
				fputc  ( 0, o_fp );
			}

			//
			// Output middle weird stuff
			//

			fputc  ( 0, o_fp );
			fputc  ( 0, o_fp );
			
			//
			// Skip Header Line
			//

			fgets ( buf3, 199, i_fp );

			//
			// Process Each Record
			//

			for (i=0; i<count; i++) {
				int j;
				long flag,pos;

				//
				// Write offset into record headers
				//

				pos = ftell( o_fp );

				fseek( o_fp, TABLE_OFFSET + (i<<3), SEEK_SET );
				fputc( (pos >> 24)&255,  o_fp );
				fputc( (pos >> 16)&255,  o_fp );
				fputc( (pos >>  8)&255,  o_fp );
				fputc(  pos       &255,  o_fp );
				fseek( o_fp, pos, SEEK_SET );


				if (ReadString( i_fp, buf3, 1999, i+1 )) {
					printf("ERROR: Missing fields in record %d\n",i);
					return 0;
				}

printf("Found record %d/%d %s\n",i+1,count,buf3);
				//-----------------------------------------
				//
				// Write custom labels, if present?
				//
				//-----------------------------------------

				if (!i && !strnicmp( buf3, "Custom", 6 )) {
					int more;

					fprintf( o_fp, "%c%c%c%cCustom Labels%c", 0,0,0,0,0 );

					// Read types

					if (ReadString( i_fp, buf4, 1999, i+1 )) {
						printf("ERROR: Missing fields in record %d\n",i);
						return 0;
					}

					// Write types

					for (j=0; j<TYPE_COUNT; j++) {				
						char *tptr;

						tptr = ScanLine( j?NULL:buf4, "\012\015" );

						if (strlen(tptr)>39) {
							printf("ERROR: Type name max size (40) exceeded in record %d\n",i);
							return 0;
						}

						strcpy(type_names[j], tptr);

						for ( k=0; type_names[j][k]; k++ ) if (type_names[j][k]==' ') type_names[j][k]='_';

						fprintf( o_fp, "%s%c", tptr,0 );
					}

					// Read classes

					more = !ReadString( i_fp, buf4, 1999, i+1 );

					// Write classes

					for (j=0; j<CLASS_COUNT; j++) {				
						char *tptr;

						tptr = ScanLine( j?NULL:buf4, "\012\015" );

						if (strlen(tptr)>19) {
							printf("ERROR: Class name max size (20) exceeded in record %d\n",i);
							return 0;
						}

						strcpy(class_names[j], tptr);

						for ( k=0; class_names[j][k]; k++ ) if (class_names[j][k]==' ') type_names[j][k]='_';

						fprintf( o_fp, "%s%c", tptr,0 );
					}

					// Write comment

					if (more) {
						if (!ReadString( i_fp, buf4, 1999, i+1 )) {
							printf("ERROR: Too many fields in record %d\n",i);
							return 0;
						}

//						if (!buf4[0]) break;	
//						fprintf( o_fp, "%s%c", buf4, 0x0a );
//						fprintf( o_fp, "%s", buf4 );
						fprintf( o_fp, "%s%c", buf4,0 );
					}
				}

				else {

					//
					// Write Type Flags
					//

					if (ReadString( i_fp, buf4, 199, i+1 )) {
						printf("ERROR: Missing fields in record %d\n",i);
						return 0;
					}
					flag = 0;
					for (j=0; j<TYPE_COUNT; j++) {				
						for (k=strlen(buf4); k--;) {				
							if (!strnicmp( &buf4[k], type_names[j], strlen(type_names[j]) )) flag |= 1L<<j;
						}
					}
					fputc( flag >> 8,  o_fp );
					fputc( flag & 255, o_fp );
					if (!flag) printf("Error! Entry %s has no valid type keywords.\n", buf3);
	
	
					//
					// Write Class Flags
					//
	
					if (ReadString( i_fp, buf4, 199, i+1 )) {
						printf("ERROR: Missing fields in record %d\n",i);
						return 0;
					}
					flag = 0;
					for (j=0; j<CLASS_COUNT; j++) {				
						for (k=strlen(buf4); k--;) {				
							if (!strnicmp( &buf4[k], class_names[j], strlen(class_names[j]) )) {
								flag |= (1L<<j);
							}
						}
					}
					fputc( flag >> 8,  o_fp );
					fputc( flag & 255, o_fp );
	
					//
					// Write Name
					//
	
					fprintf( o_fp, "%s%c", buf3, 0 );
	
					//
					// Write Description
					//
	
					{
						if (!ReadString( i_fp, buf4, 1999, i+1 )) {
							printf("ERROR: Too many fields in record %d\n",i);
							return 0;
						}
	
						fprintf( o_fp, "%s", buf4 );
					}
					fputc( 0, o_fp );
				}
			}

			printf("   %d Records written.\n",count );
			printf("   Database size %ld bytes.\n", ftell(o_fp) );

			fclose( o_fp );

		} else printf("Can't write file %s\n",name2);

		fclose( i_fp );

	} else printf("Can't read file %s\n",name1);

quit:
	if (is_mac) {
		printf("Done.  Choose 'Quit' from the 'File' menu to exit.\n");
	}

	return 0;
}


